.NOLIST
#include    "ti83plus.inc"
#include    "mirage.inc"
#include    "keys.inc"
.LIST

    .org    9D93h
    .db $BB,$6D
    ret
    .db 1
Button:
    .db %00000000,%00000000
    .db %01110011,%10011100
    .db %01110011,%10011100
    .db %01010010,%10010100
    .db %01010010,%10010100
    .db %01010010,%10010100
    .db %01010010,%10010100
    .db %01110011,%10011100
    .db %00000000,%00000000
    .db %00100011,%00011000
    .db %01100000,%10000100
    .db %00100001,%00001000
    .db %00100010,%00000100
    .db %01110011,%10011000
    .db %00000000,%00000000
Descrition:
    .db "Lucifer for Mirage 2.1",0

Lucifers    = Saferam3
Turn        = Lucifers + 1
Chosen      = Turn + 1

START:
    call    init
    call    mainscreen
MAINLOOP:
    ld    a,(Lucifers)
    cp    0
    jp    z,lose_win
    
    ld    a,(Turn)
    or    0
    jp    nz,computer
    ;jp   z,human
    
;***************************************;

HUMAN:
     call clear_bottom
     ld   a,(Chosen)
     call draw_blocks
     call draw_numbers
     ld   a,(Chosen)
     call select
NUMBERLOOP:
     call FastCopy
NUMBERLOOPB:
     bcall(_getcsc)
     cp   G_LEFT
     jp   z,decnumber
     cp   G_2nd
     jp   z,is_possible
     cp   G_ENTER
     jp   z,is_possible
     cp   G_MODE
     jp   z,the_end
     cp   G_CLEAR
     jp   z,the_end
     cp   G_RIGHT
     jp   nz,numberloopB
INCNUMBER:
     ld   a,(Chosen)
     cp   3
     jr   z,numberloop
     inc  a
     ld   (Chosen),a
     dec  a
CHANGENUMBER:
     call select
     ld   a,(Chosen)
     call select
     jr   numberloop
DECNUMBER:
     ld   a,(Chosen)
     cp   1
     jr   z,numberloop
     dec  a
     ld   (Chosen),a
     inc  a
     jr   changenumber
    
;***************************************;

COMPUTER:
     ld   a,(Lucifers)   ;(x-1) modulatie 4
     dec  a
     ld   c,a
     sra  a
     sra  a
     add  a,a
     add  a,a
     ld   b,a
     ld   a,c
     sub  b
     cp   0
     call z,random
     ld   (Chosen),a
SHOW_COMPUTER:
     call clear_bottom
     ld   hl,3410h
     ld   (PENCOL),hl
     ld   hl,strCalc
     call show_chosen
     call pause
     jp delete_lucifers

;***************************************;
IS_POSSIBLE:
     ld   a,(Chosen)
     ld   b,a
     ld   a,(Lucifers)
     sub  b
     add  a,2
     cp   1
     jp   z,numberloopb
     cp   0
     jp   z,numberloopb
SHOW_HUMAN:
     call clear_bottom
     ld   hl,3410h       ;(52*256+16)
     ld   (PENCOL),hl
     ld   hl,strYou
     call show_chosen
     call pause

DELETE_LUCIFERS:
     ld   a,(Lucifers)
     ld   c,a
     ld   a,(Chosen)
     ld   b,a
DELETE_LOOP:
     call clear_lucifers
     dec  c
     djnz delete_loop
     ld   a,c
     ld   (Lucifers),a
NEXT_PLAYER:
     ld   a,1
     ld   (Chosen),a
     ld   a,(Turn)
     xor  1
     ld   (Turn),a
     jp   mainloop

;***************************************;

LOSE_WIN:
     bcall(_clrlcdfull)
     bcall(_grbufclr)
     ld   a,(Turn)
     or   a
     jr   z,score_human
     ;jr  nz,score_computer
SCORE_COMPUTER:
     ld   hl,$0E0F
     ld   (PENCOL),hl
     ld   hl,strYouLose
     bcall(_vputs)
     ld   hl,$2E0F
     ld   (PENCOL),hl
     ld   hl,strCalcWin
     bcall(_vputs)
     call FastCopy
     call pause
     jr   the_end

SCORE_HUMAN:
     ld   hl,$0E0F
     ld   (PENCOL),hl
     ld   hl,strYouWin
     bcall(_vputs)
     ld   hl,$2E0F
     ld   (PENCOL),hl
     ld   hl,strCalcLose
     bcall(_vputs)
     call FastCopy
     call pause
     jr   the_end
     
THE_END:
     bcall(_clrlcdfull)
     bcall(_grbufclr)
     ld   hl,$0E0F
     ld   (PENCOL),hl
     ld   hl,strCredits1
     bcall(_vputs)
     ld   hl,$2E0F
     ld   (PENCOL),hl
     ld   hl,strCredits2
     bcall(_vputs)
     call FastCopy
     call pause
     ret

;***************************************;
;              SUBROUTINES              ;
;***************************************;

INIT:
     ld    a,15
     ld    (Lucifers),a
     ld    a,0
     ld    (Turn),a
     ld    a,1
     ld    (Chosen),a
     bcall(_clrlcdfull)
     bcall(_runindicoff)
     ld    hl,splash
     ld    de,plotsscreen
     ld    bc,768
     ldir
     call  FastCopy
     call Pause
     set   textwrite,(iy+sgrflags)
     ret

;***************************************;

MAINSCREEN:
    bcall(_clrlcdfull)
    bcall(_grbufclr)
    ld    hl,head
    ld    de,plotsscreen
    ld    bc,108
    ldir
    call  draw_lucifers
    ld    a,(chosen)
    call  draw_blocks
    call  draw_numbers
    call  FastCopy

    ld    a,(chosen)
    call  select
    call  FastCopy
    ret

;***************************************;

DRAW_LUCIFERS:
    ld    de,plotsscreen+180  ;line 15
    ld    hl,lucifer_head
    ld    bc,12
    ldir
    ld    hl,plotsscreen+180  ;line 15
    ld    de,plotsscreen+192  ;line 16
    ld    bc,48               ;4 times 12 (4 lines)
    ldir
    ld    hl,lucifer_head
    ld    de,plotsscreen+552  ;line 46 (=bottom)
    ld    bc,12
    ldir
    ld    de,plotsscreen+240  ;line 20
    ld    hl,lucifer_body
    ld    bc,12
    ldir
    ld    hl,plotsscreen+240  ;line 20
    ld    de,plotsscreen+252  ;line 21
    ld    bc,300              ;4 times 12 (25 lines)
    ldir
    ret

;***************************************;

DRAW_BLOCKS:
    ld    hl,plotsscreen+627  ;line 52 column 24
    ld    d,h
    ld    e,l
    ld    a,%01111111
    ld    (hl),a
    inc   hl
    rlca
    ld    (hl),a
    inc   hl
    ex    de,hl
    ld    bc,4
    ldir
    
    ld    de,plotsscreen+752  ;the end of line 62 (ln 62,cl 72)
    inc   hl
    ld    bc,6
    lddr

    ld    hl,plotsscreen+639  ;line 53 column 24
    ld    d,h
    ld    e,l
    ld    a,%10000000
    ld    (hl),a
    inc   hl
    rlca
    ld    (hl),a
    inc   hl
    ex    de,hl
    ld    bc,4
    ldir

    ld    hl,plotsscreen+636  ;line 53 column 24
    ld    de,plotsscreen+648  ;line 54
    ld    bc,96           ;8 times 12
    ldir
    ret

;***************************************;

DRAW_NUMBERS:
    ld    a,$1F
    ld    (PENCOL),a
    ld    a,$36
    ld    (PENROW),a
    ld    hl,str1
    bcall(_vputs)
    ld    a,(PENCOL)
    add   a,$C
    ld    (PENCOL),a
    ld    hl,str2
    bcall(_vputs)
    ld    a,(PENCOL)
    add   a,$C
    ld    (PENCOL),a
    bcall(_vputs)
    call  FastCopy
    ret

;***************************************;

CLEAR_BOTTOM:
    ld  hl,plotsscreen+612
    ld  b,168               ;14 times 12
    ld  a,%00000000
LOOP1:
    ld  (hl),a
    inc hl
    djnz loop1
    ret

;***************************************;

SELECT:
    sub   1
    add   a,a
    ld    e,a
    ld    d,0
    ld    hl,plotsscreen+639  ;line 53 column 24
    add   hl,de
    ld    de,11
    ld    b,9
INVERT:
    ld    a,(hl)
    xor   %01111111
    ld    (hl),a
    inc   hl
    ld    a,(hl)
    xor   %11111110
    ld    (hl),a
    add   hl,de
    djnz  invert
    ret

;***************************************;

RANDOM:
     ld   b,3
     call iRandom
     add  a,1
     
     ld   c,a
     ld   b,a
     ld   a,(Lucifers)
     sub  b
     add  a,2
     cp   1
     jr   z,random
     cp   0
     jr   z,random
     ld   a,c
     ret

;***************************************;
SHOW_CHOSEN:
     bcall(_vputs)
     ld   hl,344Bh       ;(52*256+75)
     ld   (PENCOL),hl
     call convert_number
     bcall(_vputs)
     call FastCopy
     ret

;***************************************;

CONVERT_NUMBER:
     ld   a,(Chosen)
     ld   hl,str1
     cp   1
     ret  z
     ld   hl,str2
     cp   2
     ret  z
     ld   hl,str3
     ret

;***************************************;

CLEAR_LUCIFERS:
     ld   a,c
     sub  1
     ld   l,a
     add  a,a \ add  a,a \ add  a,l
     add  a,13
     push bc
     push de
     
     ld   b,a            ;x-coordinate lower point
     ld   d,a            ;x-coordinate upper point
     ld   c,17           ;y-coordinate lower point
     ld   e,48           ;y-coordinate upper point
     ld   h,0            ;turn the points off
     bcall(_iline)
     
     dec  b
     dec  d
     bcall(_iline)
     dec  b
     dec  d
     bcall(_iline)
     
     pop  de
     pop  bc
     
     ret

;***************************************;

PAUSE:
     bcall(_getcsc)
     or   a
     jr   z,pause
     ret

;***************************************;
;                STRINGS                ;
;***************************************;
str1:          .db "1",0
str2:          .db "2",0
str3:          .db "3",0
strYou:        .db "You have chosen:",0
strCalc:       .db "Calc has chosen:",0
strYouWin:     .db "You are victorious",0
strCalcWin:    .db "Your Calc won !!!!",0
strYouLose:    .db "You are the loser!",0
strCalcLose:   .db "The Calc failed...",0
strCredits1:   .db "Made by Joris Peeraer",0
strCredits2:   .db "Copyright (c) 2003",0

;***************************************;
;               PICTURES                ;
;***************************************;
lucifer_body:
.db $00,$14,$A5,$29,$4A,$52,$94,$A5,$29,$4A,$50,$00

lucifer_head:
.db $00,$1C,$E7,$39,$CE,$73,$9C,$E7,$39,$CE,$70,$00

splash:
#include "splash02.asm"

head:
.db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
.db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
.db $FF,$FF,$FF,$FF,$BA,$C8,$88,$9F,$FF,$FF,$FF,$FF
.db $FF,$FF,$FF,$FF,$BA,$BD,$BB,$AF,$FF,$FF,$FF,$FF
.db $FF,$FF,$FF,$FF,$BA,$BD,$99,$9F,$FF,$FF,$FF,$FF
.db $FF,$FF,$FF,$FF,$BA,$BD,$BB,$AF,$FF,$FF,$FF,$FF
.db $FF,$FF,$FF,$FF,$88,$C8,$B8,$AF,$FF,$FF,$FF,$FF
.db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
.db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

.end
END